
program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Dongle in '../dcu/Dongle.pas';
var
	dwRet:LongWord;
  nCount:Integer;
  AdminPin: array [0 .. 16] of AnsiChar='FFFFFFFFFFFFFFFF'; //ĬϿPIN
  nRemainCount:Integer=0;
  i:integer;
  hDongle:Pointer;

  sm2Pub:ECCSM2_PUBLIC_KEY; //ECCԿSM2Կṹͬ
	sm2Pri:ECCSM2_PRIVATE_KEY ; //ECC˽ԿSM2˽Կṹͬ
	priAttr:PRIKEY_FILE_ATTR ;
	wPriID:word = $1111;

  nLen :integer= 0;
	pSign:array [0..63]of Byte; //ǩݹ̶64ֽ
	pHash:array [0..23]of Byte; //192λĲ24ֽڣ256λĲ32ֽ
	nHashData :integer= 24;




procedure ShowBinHex(pBin: pbyte; len: integer);
var
  i: integer;
  x: pbyte;
begin
  x := pBin;

  for i := 0 to len - 1 do
  begin
       write(IntToHex((x)^, 2), ' ');
    inc(x);
    if (i + 1) mod 16 = 0 then
      writeln('');
    end;
  writeln('');
end;


begin
  try
    { TODO -oUser -cConsole Main : Insert code here }

        for i := 0 to 23 do pHash[i] := i;
  	//ö
	dwRet := Dongle_Enum(nil, @nCount);
  if dwRet <> 0 then
    begin
    writeln('Dongle_Enum() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('Enum :', nCount,'Dongle.');

   		// 
	dwRet := Dongle_Open(@hDongle, 0);
  if dwRet <> 0 then
    begin
    writeln('Dongle_Open() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('Open Dongle. Return :', dwRet);

    	//֤PIN
 	dwRet := Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN,AdminPin, @nRemainCount);
  if dwRet <> 0 then
    begin
    writeln('Dongle_VerifyPIN() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('Verify Admin PIN. Return:', dwRet);

   //ECC˽Կ
	priAttr.m_Size := $8100;//Ҳ256
	priAttr.m_Type := FILE_PRIKEY_RSA;
	priAttr.m_Lic.m_Count :=$FFFFFFFF;//ɵô
	priAttr.m_Lic.m_IsDecOnRAM := char(0);//ǷΪڴеݼ
	priAttr.m_Lic.m_IsReset := char(0);//Ƿָ̬
	priAttr.m_Lic.m_Priv := char(0);//ɵõСȨ
	
	dwRet := Dongle_CreateFile(hDongle, FILE_PRIKEY_ECCSM2, wPriID, Pointer(@priAttr));
  if dwRet <> 0 then
    begin
    writeln('Dongle_CreateFile() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('Create ECC private key file. Return:', dwRet);


  //SM2˽Կ
	dwRet := Dongle_SM2GenPubPriKey(hDongle, wPriID,@sm2Pub,@sm2Pri);
  if dwRet <> 0 then
    begin
    writeln('Dongle_SM2GenPubPriKey() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('Gen SM2 Public key and private key. Return:', dwRet);

  //ECC˽Կǩ
	dwRet := Dongle_SM2Sign(hDongle, wPriID, PByte(@pHash[0]), nHashData, PByte(@pSign[0]));
  if dwRet <> 0 then
    begin
    writeln('Dongle_SM2Sign() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('SM2 private key sign. Return:', dwRet);

	//ECCԿǩ
	dwRet := Dongle_SM2Verify(hDongle, @sm2Pub, PByte(@pHash[0]), nHashData, PByte(@pSign[0]));
  if dwRet <> 0 then
    begin
    writeln('Dongle_SM2Verify() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('SM2 public key verify success. Return:', dwRet);


	//ɾESM2˽Կ
	dwRet := Dongle_DeleteFile(hDongle, FILE_PRIKEY_ECCSM2, wPriID);
  if dwRet <> 0 then
    begin
    writeln('Dongle_DeleteFile() dwRet=', IntToHex(dwRet, 8));
    readln;
      exit;
    end;
  writeln('Delete SM2 private key file. Return:', dwRet);

 	//رռ
	dwRet := Dongle_Close(hDongle);
  writeln('Close Dongle. Return :', dwRet);
   readln;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
  readln;
end.

