unit Dongle;

interface

uses
  Windows, SysUtils, Classes;

const
//  ===========================================================
//Dongle_Core
DIGCF_DEFAULT           = $00000001;
DIGCF_PRESENT           = $00000002;
DIGCF_ALLCLASSES        = $00000004;
DIGCF_PROFILE           = $00000008;
DIGCF_DEVICEINTERFACE   = $00000010;
DIGCF_INTERFACEDEVICE   = $00000010;

FT_CCID_VendorID       = $096E;
FT_CCID_ProductID      = $020A;//µΪ:0x020A
//PID&VID
FT_HID_VendorID       = $096E;
FT_HID_ProductID      = $0209; //µΪ:0x0209
//ͨ
 R7_SUCCESS           =$9000  ;//ɹ
 R7_INVALID_INS       =$6C00  ;//ЧINS
 R7_INVALID_P1        =$6C01  ;//ЧP1
 R7_INVALID_P2        =$6C02  ;//ЧP2
 R7_INVALID_LEN       =$6C03  ;//ЧLEN(p3,p4)
 R7_INVALID_PARAM     =$6C04  ;//ЧĲ(:еһЩ)
 RY_FAILED            =$6C05  ;//ʧ
 RX_EXPIRE            =$6C06  ;//ѹ(ʱ)

//д
 R7_READ_ERR          =$6B00  ;//ݴ
 R7_WRITE_ERR         =$6B01  ;//дݴ

//ļϵͳ
 R7_DIR_EXIST         =$6A80  ;//ļѴ
 R7_DIR_NOTFOUND      =$6A81  ;//ļв
 R7_FILE_EXIST        =$6A82  ;//ļѴ
 R7_FILE_NOTFOUND     =$6A83  ;//ļ

 R7_FILE_CFILE_ERR    =$6A86  ;//ļʧ
 R7_FILE_READ_ERR     =$6A87  ;//ļʧ
 R7_FILE_WRITE_ERR    =$6A88  ;//дļʧ
 R7_FILE_DFILE_ERR    =$6A89  ;//ɾļʧ
 R7_FILE_CDIR_ERR     =$6A8A  ;//ļʧ
 R7_FILE_DDIR_ERR     =$6A8B  ;//ɾļʧ
 R7_FILE_TOOLARGE     =$6A8C  ;//ļ̫

//Ȩ
 R7_NOT_INITED        =$6980  ;//δʼ
 R7_ALREADY_INITED    =$6981  ;//ѳʼ
 R7_ADMINPIN_NOTCHECK =$6982  ;//ԱPINûУ
 R7_USERPIN_NOTCHECK  =$6983  ;//ûPINûУ
 R7_PIN_BLOCKED       =$6984  ;//PINѱ
 R7_RUN_LIMITED       =$6985  ;//(:˽Կ㡢)
 R7_INITSON_ERR       =$6986  ;//ʼʧ
 R7_NOTMOTHER_ERR     =$6987  ;//ĸ

//
 RY_PIN_ERROR         =$6800  ;//PIN,λָʾʣ
 //===================================================
 APDU_COMMAND_SIZE	      =8;
 MAX_PACKET_SIZE		 =1032; //APDU󳤶


 MAX_PINLEN               =16 ;//ûPIN󳤶

//ļļID
 DIRID_3F00           =$3F00;
 DIRID_0000           =$0000;
 DIRID_FFFF           =$FFFF;

 DIRID_MIN            =$0001;
 DIRID_MAX            =$3EFF;

 LED_GENRANDOM             =3 ;//LED޹,

 CHANGE_USERPIN            =0 ;//ûPIN
 CHANGE_ADMINPIN           =1 ;//ĹԱPIN
 RESET_USERPIN             =2 ;//ûPIN

 INIT_PID_ADMINPIN         =0 ;//ƷID and Ա
 INIT_RFS                  =1 ;//ָ
 INIT_INTERFACE            =2 ;//USB

 FLAG_RSA1024              =0;
 FLAG_RSA2048              =1;
 FLAG_ECC192               =2;
 FLAG_ECC256               =3;

//豸
 DEVICE_TYPE_HID           =0;
 DEVICE_TYPE_CCID          =1;


 
 MAX_DATA_SIZE        =1024;
 HID_INT_BUFF_SIZE    =58;  //64-6 
// Dongle_core
//±߶Dongle_API.h
//õPID
CONST_PID               :integer =	integer($FFFFFFFF);   //ʱĬϵPID
CONST_USERPIN          :AnsiString=AnsiString('12345678'); //ʱĬϵUSERPIN
CONST_ADMINPIN         :AnsiString=AnsiString('FFFFFFFFFFFFFFFF');  //ʱĬϵADMINPIN

//ͨѶЭͶ
PROTOCOL_HID            =0 ;//hidЭ
 PROTOCOL_CCID           =1 ;//ccidЭ

//ļͶ
 FILE_DATA               =1 ;//ͨļ
 FILE_PRIKEY_RSA         =2 ;//RSA˽Կļ
 FILE_PRIKEY_ECCSM2      =3 ;//ECCSM2˽Կļ(SM2˽ԿļʱECC˽ԿļӼ)
 FILE_KEY                =4 ;//SM43DESԿļ
 FILE_EXE                =5 ;//ִļ

//LED״̬
 LED_OFF			        =0 ;//
 LED_ON			        =1 ;//
 LED_BLINK		       = 2 ;//

//PIN
 FLAG_USERPIN   			=0 ;//ûPIN
 FLAG_ADMINPIN			=1 ;//PIN

//ӽܱ־
 FLAG_ENCODE             =0 ;//
 FLAG_DECODE             =1 ;//

//HASH㷨
 FLAG_HASH_MD5           =0 ;//MD5     16ֽ
 FLAG_HASH_SHA1          =1 ;//SHA1    20ֽ
 FLAG_HASH_SM3           =2 ;//SM3     32ֽ

//ԶĹܺ
 UPDATE_FUNC_CreateFile     =1 ;//ļ
 UPDATE_FUNC_WriteFile      =2 ;//дļ
 UPDATE_FUNC_DeleteFile     =3 ;//ɾļ
 UPDATE_FUNC_FileLic        =4 ;//ļȨ
 UPDATE_FUNC_SeedCount      =5 ;//
 UPDATE_FUNC_DownloadExe    =6 ;//ִļ
 UPDATE_FUNC_UnlockUserPin  =7 ;//ûPIN
 UPDATE_FUNC_Deadline       =8 ;//ʱʹ

 //
   DONGLE_SUCCESS                       =$00000000 ;// ɹ
   DONGLE_NOT_FOUND                     =$F0000001 ;// δҵָ豸
   DONGLE_INVALID_HANDLE				   =$F0000002 ;// Чľ
   DONGLE_INVALID_PARAMETER			   =$F0000003 ;// 
   DONGLE_COMM_ERROR					     =$F0000004;// ͨѶ
   DONGLE_INSUFFICIENT_BUFFER		   =$F0000005		   ;// ռ䲻
   DONGLE_NOT_INITIALIZED          =$F0000006		   ;// Ʒδʼ (ûPID)
   DONGLE_ALREADY_INITIALIZED		   =$F0000007		   ;// ƷѾʼ (PID)
   DONGLE_ADMINPIN_NOT_CHECK			 =$F0000008		   ;// û֤
   DONGLE_USERPIN_NOT_CHECK			   =$F0000009		   ;// ûû֤
   DONGLE_INCORRECT_PIN				     =$F000FF00		   ;// 벻ȷ (2λָʾʣ)
   DONGLE_PIN_BLOCKED				       =$F000000A		   ;// PIN
   DONGLE_ACCESS_DENIED				     =$F000000B		   ;// ʱܾ

   DONGLE_FILE_EXIST					     =$F000000E		   ;// ļѴ
   DONGLE_FILE_NOT_FOUND				   =$F000000F		   ;// δҵָļ
	  DONGLE_READ_ERROR              =$F0000010          ;// ȡݴ
	  DONGLE_WRITE_ERROR             =$F0000011          ;// дݴ
	  DONGLE_FILE_CREATE_ERROR       =$F0000012          ;// ļļд
	  DONGLE_FILE_READ_ERROR         =$F0000013          ;// ȡļ
	  DONGLE_FILE_WRITE_ERROR        =$F0000014          ;// дļ
	  DONGLE_FILE_DEL_ERROR           =$F0000015          ;// ɾļļд
   DONGLE_FAILED                     =   $F0000016          ;// ʧ
   DONGLE_INVALID_MODULE              =  $F0000017          ;// ʱӵ
  
   DONGLE_ERROR_UNKNOWN		           =$FFFFFFFF		   ;// δ֪Ĵ
//ϱ߶Dongle_API.h

type
    PWord = ^Word;
    PLongword = ^Longword;
    PHIDP_PREPARSED_DATA = ^Byte;
    PPHIDP_PREPARSED_DATA = ^PHIDP_PREPARSED_DATA;
    PCSTR = ^Char;
    PByte = ^Byte;
    psize_t = ^size_t;
    size_t = Cardinal;
    //   begin arm
    PPLongword=^PLongword;


    tm=record
        tm_sec:integer;     //* seconds after the minute - [0,59] */
         tm_min:integer;     //* minutes after the hour - [0,59] */
        tm_hour:integer;    //* hours since midnight - [0,23] */
        tm_mday:integer;    //* day of the month - [1,31] */
        tm_mon:integer;     //* months since January - [0,11] */
        tm_year:integer;    //* years since 1900 */
        tm_wday:integer;    //* days since Sunday - [0,6] */
        tm_yday:integer;    //* days since January 1 - [0,365] */
        tm_isdst:integer;   //* daylight savings time flag */
    end;
    ptm=^tm;


    //   end arm


DONGLE_INFO = record
  m_Ver:word;               //COS汾,:0x0201,ʾ2.01
 m_Type:word;              //Ʒ: 0xFFʾ׼, 0x00Ϊʱ,0x01ΪʱӵU,0x02Ϊ׼U
	m_BirthDay:array[0..7] of Ansichar;       //(BCDʱ)
	m_Agent:longword;             //̱,:Ĭϵ0xFFFFFFFF
	m_PID:longword;               //ƷID
	m_UserID:longword;            //ûID
	m_HID:array[0..7] of Ansichar;            //8ֽڵӲID
	m_IsMother:longword;          //ĸ־: 0x01ʾĸ, 0x00ʾĸ
	m_DevType:longword;           //豸(PROTOCOL_HIDPROTOCOL_CCID)
end;
PDONGLE_INFO = ^DONGLE_INFO;

//غпִļʱݽṹ
EXE_FILE_INFO=record
	m_dwSize:word;           //ִļС
	m_wFileID:word;          //ִļID
	m_Priv:Ansichar;             //Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
  m_pData:pAnsichar;            //ִļ
end;
pEXE_FILE_INFO=^EXE_FILE_INFO;
//RSAԿʽ(1024,2048)
RSA_PUBLIC_KEY = record
	bits : longword;					              // length in bits of modulus
	modulus : longword;							        // modulus
	exponent : array[0..255] of Ansichar;		// public exponent
end;
pRSA_PUBLIC_KEY=^RSA_PUBLIC_KEY;
//RSA˽Կʽ(1024,2048)
RSA_PRIVATE_KEY = record
	bits : longword;						                // length in bits of modulus
	modulus : longword;							            // modulus
	publicExponent : array[0..255] of Ansichar;	// public exponent
  exponent : array[0..255] of Ansichar;       // private exponent
end;
pRSA_PRIVATE_KEY=^RSA_PRIVATE_KEY;
//ⲿECCSM2Կʽ (192,256)SM2(̶Ϊbits=0x8100)Կʽ
ECCSM2_PUBLIC_KEY = record
	bits:longword;                    // length in bits of modulus
	XCoordinate:array[0..7] of longword;          // ϵX
	YCoordinate:array[0..7] of longword;         // ϵY
end;
pECCSM2_PUBLIC_KEY=^ECCSM2_PUBLIC_KEY;
//ⲿECCSM2˽Կʽ (192,256)SM2(̶Ϊbits=0x8100)˽Կʽ
ECCSM2_PRIVATE_KEY = record
	bits:longword;                    // length in bits of modulus
	PrivateKey:array[0..7] of longword;           // ˽Կ
end;
pECCSM2_PRIVATE_KEY=^ECCSM2_PRIVATE_KEY;

//Ҫĳʼ
SON_DATA=record
	m_SeedLen:integer;                 //볤
	m_SeedForPID:array[0..255]of byte;         //ƷIDͿ (250ֽ)
	m_UserPIN:array [0..17]of Ansichar;             //û(16ַ0ַֹ)
	m_UserTryCount:byte;            //ûԴ
	m_AdminTryCount:byte;           //Դ
  m_UpdatePriKey:RSA_PRIVATE_KEY;   //Զ˽Կ
	m_UserID_Start:longword;            //ʼûID
end;
pSON_DATA=^SON_DATA;
//ĸ
MOTHER_DATA=record
  m_Son:SON_DATA;                  //ʼ
	m_Count:longword;                //ɲʼݵĴ (-1ʾƴ, ݼ0ʱ)
end;
pMOTHER_DATA=^MOTHER_DATA;

//*************************ļȨṹ***********************************/
//ļȨṹ
DATA_LIC = record
	m_Read_Priv:word;      //Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
	m_Write_Priv:word;     //дȨ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
end;
//˽ԿļȨṹ
PRIKEY_LIC=record
	m_Count:longword;      //ɵ: 0xFFFFFFFFʾ, ݼ0ʾѲɵ
	m_Priv:Ansichar;       //Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
	m_IsDecOnRAM:Ansichar; //Ƿڴеݼ: TRUEΪڴеݼ    FALSEΪFLASHеݼ
	m_IsReset:Ansichar;    //û̬úǷԶص̬: TRUEΪص̬ (̬ܴ)
	m_Reserve:Ansichar;    //,4ֽڶ
end;
//ԳƼ㷨(SM4/TDES)ԿļȨṹ
KEY_LIC=record
	m_Priv_Enc:longword;   //ʱĵȨ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
end;
//ԳƼ㷨ԿļȨṹ
EXE_LIC=record
  m_Priv_Exe:word;   //еȨ: 0ΪСȨ  1ΪСûȨ  2ΪСȨ
end;

 //ļݽṹ
DATA_FILE_ATTR=record
  m_Size:longword;      //ļ
  m_Lic:DATA_LIC;       //Ȩ
end;

//ȡļбʱصݽṹ
DATA_FILE_LIST=record
  m_FILEID:word;  //ļID
	m_Reserve:word; //,4ֽڶ
  m_attr:DATA_FILE_ATTR;    //ļ
end;
//ִļݽṹ
EXE_FILE_ATTR=record
	m_Lic:EXE_LIC;        //Ȩ
	m_Len:word;        //ļ
end;
//ȡִļбʱصݽṹ
EXE_FILE_LIST=record
	m_FILEID:word;    //ļID
  m_attr:EXE_FILE_ATTR;
	m_Reserve:word;  //,4ֽڶ
end;
//ECCSM2/RSA˽Կļݽṹ
PRIKEY_FILE_ATTR=record
  m_Type:word;       //:ECCSM2˽Կ  RSA˽Կ
  m_Size:word;       //ݳ:RSA 1024λ  2048λ, ECC192λ256λ, SM20x8100λ
  m_Lic:PRIKEY_LIC;        //Ȩ
end;
//ȡ˽Կļбʱصݽṹ
PRIKEY_FILE_LIST=record
	m_FILEID:word;  //ļID
	m_Reserve:word; //,4ֽڶ
  m_attr:PRIKEY_FILE_ATTR;    //ļ
end;
 //ԳƼ㷨(SM4/TDES)Կļݽṹ
KEY_FILE_ATTR=record
	m_Size:longword;       //Կݳ=16
  m_Lic:KEY_LIC;        //Ȩ
end;
//ȡSM4TDESԿļбʱصݽṹ
KEY_FILE_LIST=record
	m_FILEID:word;  //ļID
	m_Reserve:word; //,4ֽڶ
  m_attr:KEY_FILE_ATTR;    //ļ
end;

function Dongle_Enum(pDongleInfo:Pointer;pCount:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_Open(phDongle:pword;index:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ResetState(phDongle:pword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_Close(phDongle:pword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_GenRandom(phDongle:pword;nLen:integer; pRandomBuffer:pAnsichar):longword;stdcall;external 'Dongle_d.dll';
function Dongle_LEDControl(phDongle:pword;nFlag:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SwitchProtocol(phDongle:pword;nFlag:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_RFS(phDongle:pword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_CreateFile(hDongle:Pointer; nFileType:integer;wFileID:word;pFileAttr:Pointer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_WriteFile(hDongle:Pointer;nFileType:integer;wFileID:word;wOffset:word;pInData:pbyte;nDataLen:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_DownloadExeFile(hDongle:Pointer;pExeFileInfo:pEXE_FILE_INFO; nDim:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_RunExeFile(hDongle:Pointer; wFileID:word; pInOutData:pbyte; wInOutDataLen:word;pMainRet:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ReadFile(hDongle:Pointer;wFileID:word; wOffset:word;pOutData:pbyte;nDataLen:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_DeleteFile(hDongle:Pointer;nFileType:integer;wFileID:word):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ListFile(hDongle:Pointer;nFileType:integer;pFileList:pointer;pDataLen:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_GenUniqueKey(hDongle:Pointer;nSeedLen:integer;pSeed:pbyte;pPIDstr:pchar;pAdminPINstr:pchar):longword;stdcall;external 'Dongle_d.dll';
function Dongle_VerifyPIN(hDongle:Pointer;nFlags:integer;pPIN:pchar;pRemainCount:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ChangePIN(handle:Pointer;Flags:integer;pOldPIN:pchar;pNewPIN:pchar;TryCount:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ResetUserPIN(handle:Pointer;pAdminPIN:pchar):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SetUserID(handle:Pointer;UserID:longword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_GetDeadline(handle:Pointer; pdwSeconds:plongword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SetDeadline(handle:Pointer;dwSeconds:longword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ReadData(handle:Pointer; offset:integer; pData:pbyte; len:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_WriteData(handle:Pointer; offset:integer; pData:pbyte; len:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_RsaGenPubPriKey(handle:Pointer; fileid:word; pPubBakup:pRSA_PUBLIC_KEY; pPriBakup:pRSA_PRIVATE_KEY):longword;stdcall;external 'Dongle_d.dll';
function Dongle_RsaPri(handle:Pointer; fileid:word;flag:integer;pData:pbyte; len:integer; pOut:pbyte;pOutLen:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_RsaPub(handle:Pointer;flag:integer;  pPubKey:pRSA_PUBLIC_KEY; pData:pbyte; len:integer; pOut:pbyte; pOutLen:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_EccGenPubPriKey(handle:Pointer; fileid:word; pPubBakup:pECCSM2_PUBLIC_KEY;  pPriBakup:pECCSM2_PRIVATE_KEY):longword;stdcall;external 'Dongle_d.dll';
function Dongle_EccSign(handle:Pointer; fileid:word; pHash: pbyte;  len_Hash:integer; pOut:pbyte ):longword;stdcall;external 'Dongle_d.dll';
function Dongle_EccVerify(handle:Pointer;  pPubKey:pECCSM2_PUBLIC_KEY;  pHash:pbyte;  len_Hash:integer;  pSign:pbyte):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SM2GenPubPriKey(handle:Pointer; fileid:word;  pPubBakup:pECCSM2_PUBLIC_KEY;  pPriBakup:pECCSM2_PRIVATE_KEY):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SM2Sign(handle:Pointer; fileid:word;  pHash:pbyte;  len_Hash:integer; pOut:pbyte ):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SM2Verify(handle:Pointer;  pPubKey:pECCSM2_PUBLIC_KEY; pHash:pbyte ;  len_Hash:integer;  pSign:pbyte):longword;stdcall;external 'Dongle_d.dll';
function Dongle_TDES(handle:Pointer; fileid:word; flag:integer; pIn:pbyte; pOut:pbyte; len:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SM4(handle:Pointer; fileid:word; flag:integer; pIn:pbyte; pOut:pbyte; len:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_HASH(handle:Pointer; flag:integer; pData:pbyte; len:integer;  pHash:pbyte):longword;stdcall;external 'Dongle_d.dll';
function Dongle_LimitSeedCount(handle:Pointer;  count:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_Seed(handle:Pointer;  pSeed:pbyte; len_Seed:integer; pOut:pbyte):longword;stdcall;external 'Dongle_d.dll';
function Dongle_GenMotherKey(handle:Pointer;  pData:pMOTHER_DATA):longword;stdcall;external 'Dongle_d.dll';
function Dongle_RequestInit(handle:Pointer;  pData:pbyte):longword;stdcall;external 'Dongle_d.dll';
function Dongle_GetInitDataFromMother(handle:Pointer;  pRequest:pbyte;  pInitData:pbyte;  pLen:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_InitSon(handle:Pointer; pInitData: pbyte; len:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_SetUpdatePriKey(handle:Pointer; pPriKey:pRSA_PRIVATE_KEY):longword;stdcall;external 'Dongle_d.dll';
function Dongle_MakeUpdatePacket(handle:Pointer; pHID:pchar; func:integer; filetype:integer; fileid:word; offset:integer; pbuf: pbyte; len:integer;  pUPubKey:pRSA_PUBLIC_KEY; pOutData:pbyte;  pOutLen:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_MakeUpdatePacketFromMother(handle:Pointer; pHID:pchar; func:integer; filetype:integer; fileid:word; offset:integer; pbuf: pbyte; len:integer; pOutData:pbyte;  pOutLen:pinteger):longword;stdcall;external 'Dongle_d.dll';
function Dongle_Update(handle:Pointer; pData:pbyte; len:integer):longword;stdcall;external 'Dongle_d.dll';
function Dongle_GetUTCTime(hDongle:Pointer; pdwUTCTime:plongword):longword;stdcall;external 'Dongle_d.dll';
function Dongle_ReadShareMemory(hDongle:Pointer; pData:pbyte):longword;stdcall;external 'Dongle_d.dll';
function Dongle_WriteShareMemory(hDongle:Pointer; pData:pbyte;nDataLen:integer):longword;stdcall;external 'Dongle_d.dll';  
implementation
end.





















































































